"""Added unique constraint

Revision ID: c4012999477f
Revises: d7e762ef42be
Create Date: 2023-10-30 05:56:11.223361

"""
from typing import Sequence, Union

import sqlalchemy as sa
from alembic import op

# revision identifiers, used by Alembic.
revision: str = "c4012999477f"
down_revision: Union[str, None] = "d7e762ef42be"
branch_labels: Union[str, Sequence[str], None] = None
depends_on: Union[str, Sequence[str], None] = None


def upgrade() -> None:
    # ### commands auto generated by Alembic - please adjust! ###
    op.drop_index("ix_user_email", table_name="user")
    op.drop_index("ix_user_username", table_name="user")
    op.create_index(
        "idx_user_email_case_insensitive", "user", [sa.text("LOWER(email)")], unique=True
    )
    op.create_index(
        "idx_user_username_case_insensitive",
        "user",
        [sa.text("LOWER(username)")],
        unique=True,
    )
    op.alter_column(
        "usersession",
        "longitude",
        existing_type=sa.REAL(),
        type_=sa.Float(precision=10),
        existing_nullable=True,
    )
    op.alter_column(
        "usersession",
        "latitude",
        existing_type=sa.REAL(),
        type_=sa.Float(precision=10),
        existing_nullable=True,
    )
    # ### end Alembic commands ###


def downgrade() -> None:
    # ### commands auto generated by Alembic - please adjust! ###
    op.alter_column(
        "usersession",
        "latitude",
        existing_type=sa.Float(precision=10),
        type_=sa.REAL(),
        existing_nullable=True,
    )
    op.alter_column(
        "usersession",
        "longitude",
        existing_type=sa.Float(precision=10),
        type_=sa.REAL(),
        existing_nullable=True,
    )
    op.drop_index("idx_user_username_case_insensitive", table_name="user")
    op.drop_index("idx_user_email_case_insensitive", table_name="user")
    op.create_index("ix_user_username", "user", ["username"], unique=False)
    op.create_index("ix_user_email", "user", ["email"], unique=False)
    # ### end Alembic commands ###
